/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "flags.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "memmodel.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "regs.h"
#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "diagnostic-core.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char * const output_5[] = {
  "lbu      %0, %1",
  "or       %0, %1, r0",
  "sb       %0, %1",
  "sb       %0, r0",
  "addi     %0, r0, %1",
};

static const char * const output_6[] = {
  "lhu      %0, %1",
  "or       %0, %1, r0",
  "sh       %0, %1",
  "sh       %0, r0",
  "addi     %0, r0, %1",
  "ori      %0, r0, %1",
};

static const char * const output_7[] = {
  "lw       %0, %1",
  "or       %0, %1, r0",
  "sw       %0, %1",
  "sw       %0, r0",
  "addi     %0, r0, %1",
  "ori      %0, r0, %1",
  "orhi     %0, r0, hi(%1)",
  "mva      %0, gp(%1)",
  "orhi     %0, r0, hi(%1)",
  "ori      %0, r0, lo(%1); orhi     %0, %0, hi(%1)",
};

static const char * const output_8[] = {
  "lb       %0, %1",
  "sextb    %0, %1",
};

static const char * const output_9[] = {
  "lbu      %0, %1",
  "andi     %0, %1, 0xff",
};

static const char * const output_10[] = {
  "lb       %0, %1",
  "sextb    %0, %1",
};

static const char * const output_11[] = {
  "lbu      %0, %1",
  "andi     %0, %1, 0xff",
};

static const char * const output_12[] = {
  "lh       %0, %1",
  "sexth    %0, %1",
};

static const char * const output_13[] = {
  "lhu      %0, %1",
  "andi     %0, %1, 0xffff",
};

static const char * const output_14[] = {
  "cmpe     %0, %z1, %2",
  "cmpei    %0, %z1, %2",
};

static const char * const output_15[] = {
  "cmpne    %0, %z1, %2",
  "cmpnei   %0, %z1, %2",
};

static const char * const output_16[] = {
  "cmpg     %0, %z1, %2",
  "cmpgi    %0, %z1, %2",
};

static const char * const output_17[] = {
  "cmpge    %0, %z1, %2",
  "cmpgei   %0, %z1, %2",
};

static const char * const output_18[] = {
  "cmpgu    %0, %z1, %2",
  "cmpgui   %0, %z1, %2",
};

static const char * const output_19[] = {
  "cmpgeu   %0, %z1, %2",
  "cmpgeui  %0, %z1, %2",
};

static const char *
output_22 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 502 "../../gcc/config/lm32/lm32.md"
{
  return get_attr_length (insn) == 4
        ? "be     %z0,%z1,%2"
        : "bne    %z0,%z1,8\n\tbi     %2";
}
}

static const char *
output_23 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 516 "../../gcc/config/lm32/lm32.md"
{
  return get_attr_length (insn) == 4
        ? "bne    %z0,%z1,%2"
        : "be     %z0,%z1,8\n\tbi     %2";
}
}

static const char *
output_24 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 530 "../../gcc/config/lm32/lm32.md"
{
  return get_attr_length (insn) == 4
        ? "bg     %z0,%z1,%2"
        : "bge    %z1,%z0,8\n\tbi     %2";
}
}

static const char *
output_25 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 544 "../../gcc/config/lm32/lm32.md"
{
  return get_attr_length (insn) == 4
        ? "bge    %z0,%z1,%2"
        : "bg     %z1,%z0,8\n\tbi     %2";
}
}

static const char *
output_26 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 558 "../../gcc/config/lm32/lm32.md"
{
  return get_attr_length (insn) == 4
        ? "bgu    %z0,%z1,%2"
        : "bgeu   %z1,%z0,8\n\tbi     %2";
}
}

static const char *
output_27 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 572 "../../gcc/config/lm32/lm32.md"
{
  return get_attr_length (insn) == 4
        ? "bgeu   %z0,%z1,%2"
        : "bgu    %z1,%z0,8\n\tbi     %2";
}
}

static const char * const output_28[] = {
  "call     %0",
  "calli    %0",
};

static const char * const output_29[] = {
  "call     %1",
  "calli    %1",
};

static const char * const output_34[] = {
  "add      %0, %z1, %2",
  "addi     %0, %z1, %2",
};

static const char * const output_36[] = {
  "mul      %0, %z1, %2",
  "muli     %0, %z1, %2",
};

static const char * const output_41[] = {
  "and      %0, %z1, %2",
  "andi     %0, %z1, %2",
};

static const char * const output_42[] = {
  "or       %0, %z1, %2",
  "ori      %0, %z1, %2",
};

static const char * const output_43[] = {
  "xor      %0, %z1, %2",
  "xori     %0, %z1, %2",
};

static const char * const output_44[] = {
  "nor      %0, %z1, %2",
  "nori     %0, %z1, %2",
};

static const char * const output_45[] = {
  "xnor     %0, %z1, %2",
  "xnori    %0, %z1, %2",
};

static const char * const output_46[] = {
  "sl       %0, %z1, %2",
  "sli      %0, %z1, %2",
};

static const char * const output_47[] = {
  "sr       %0, %z1, %2",
  "sri      %0, %z1, %2",
};

static const char * const output_49[] = {
  "sru      %0, %z1, %2",
  "srui     %0, %z1, %2",
};



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reloc_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "=r,r,m,m,r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "m,r,r,J,n",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,m,m,r,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "m,r,r,J,K,L",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,m,m,r,r,r,r,r,r",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "m,r,r,J,K,L,U,S,Y,n",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r,r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "m,r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "m,r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "m,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_zero_operand,
    "%rJ,rJ",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_K_operand,
    "r,K",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_zero_operand,
    "rJ,rJ",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_K_operand,
    "r,K",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_zero_operand,
    "rJ,rJ",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_L_operand,
    "r,L",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_zero_operand,
    "rJ",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_zero_operand,
    "rJ",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_operand,
    "r,s",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_operand,
    "r,s",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_zero_operand,
    "rJ",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_zero_operand,
    "rJ",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_zero_operand,
    "rJ",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_zero_operand,
    "%rJ,rJ",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_L_operand,
    "r,L",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_zero_operand,
    "rJ",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    constant_M_operand,
    "M",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_BLKmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_BLKmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_zero_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_or_L_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data_d insn_data[] = 
{
  /* <internal>:0 */
  {
    "*placeholder_for_nothing",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:235 */
  {
    "movsi_got",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "lw       %0, (gp+got(%1))",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_got },
    &operand_data[1],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:243 */
  {
    "movsi_gotoff_hi16",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "orhi     %0, r0, gotoffhi16(%1)",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_gotoff_hi16 },
    &operand_data[1],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:251 */
  {
    "movsi_gotoff_lo16",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "addi     %0, %1, gotofflo16(%2)",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_gotoff_lo16 },
    &operand_data[3],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:260 */
  {
    "*movsi_lo_sum",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ori      %0, %0, lo(%2)",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[6],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:269 */
  {
    "*movqi_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_5 },
#else
    { 0, output_5, 0 },
#endif
    { 0 },
    &operand_data[9],
    2,
    2,
    0,
    5,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:282 */
  {
    "*movhi_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_6 },
#else
    { 0, output_6, 0 },
#endif
    { 0 },
    &operand_data[11],
    2,
    2,
    0,
    6,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:296 */
  {
    "movsi_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_7 },
#else
    { 0, output_7, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_insn },
    &operand_data[13],
    2,
    2,
    0,
    10,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:318 */
  {
    "*extendqihi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_8 },
#else
    { 0, output_8, 0 },
#endif
    { 0 },
    &operand_data[15],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:328 */
  {
    "zero_extendqihi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_9 },
#else
    { 0, output_9, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqihi2 },
    &operand_data[15],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:338 */
  {
    "*extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_10 },
#else
    { 0, output_10, 0 },
#endif
    { 0 },
    &operand_data[17],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:348 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_11 },
#else
    { 0, output_11, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqisi2 },
    &operand_data[17],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:358 */
  {
    "*extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_12 },
#else
    { 0, output_12, 0 },
#endif
    { 0 },
    &operand_data[19],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:368 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_13 },
#else
    { 0, output_13, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisi2 },
    &operand_data[19],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:393 */
  {
    "*seq",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_14 },
#else
    { 0, output_14, 0 },
#endif
    { 0 },
    &operand_data[21],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:404 */
  {
    "*sne",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_15 },
#else
    { 0, output_15, 0 },
#endif
    { 0 },
    &operand_data[21],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:415 */
  {
    "*sgt",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_16 },
#else
    { 0, output_16, 0 },
#endif
    { 0 },
    &operand_data[24],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:426 */
  {
    "*sge",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_17 },
#else
    { 0, output_17, 0 },
#endif
    { 0 },
    &operand_data[24],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:437 */
  {
    "*sgtu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_18 },
#else
    { 0, output_18, 0 },
#endif
    { 0 },
    &operand_data[27],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:448 */
  {
    "*sgeu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_19 },
#else
    { 0, output_19, 0 },
#endif
    { 0 },
    &operand_data[27],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:463 */
  {
    "jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "bi       %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_jump },
    &operand_data[2],
    1,
    1,
    0,
    0,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:470 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "b        %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump },
    &operand_data[30],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:495 */
  {
    "*beq",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_22 },
#else
    { 0, 0, output_22 },
#endif
    { 0 },
    &operand_data[31],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/lm32/lm32.md:509 */
  {
    "*bne",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_23 },
#else
    { 0, 0, output_23 },
#endif
    { 0 },
    &operand_data[31],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/lm32/lm32.md:523 */
  {
    "*bgt",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_24 },
#else
    { 0, 0, output_24 },
#endif
    { 0 },
    &operand_data[31],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/lm32/lm32.md:537 */
  {
    "*bge",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_25 },
#else
    { 0, 0, output_25 },
#endif
    { 0 },
    &operand_data[31],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/lm32/lm32.md:551 */
  {
    "*bgtu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_26 },
#else
    { 0, 0, output_26 },
#endif
    { 0 },
    &operand_data[31],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/lm32/lm32.md:565 */
  {
    "*bgeu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_27 },
#else
    { 0, 0, output_27 },
#endif
    { 0 },
    &operand_data[31],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/lm32/lm32.md:596 */
  {
    "*call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_28 },
#else
    { 0, output_28, 0 },
#endif
    { 0 },
    &operand_data[34],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:621 */
  {
    "*call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_29 },
#else
    { 0, output_29, 0 },
#endif
    { 0 },
    &operand_data[36],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:633 */
  {
    "return_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "b        %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return_internal },
    &operand_data[30],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:653 */
  {
    "*return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ret",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:660 */
  {
    "*simple_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ret",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:690 */
  {
    "tablejumpsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "b        %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejumpsi },
    &operand_data[39],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:702 */
  {
    "addsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_34 },
#else
    { 0, output_34, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3 },
    &operand_data[21],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:713 */
  {
    "subsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub      %0, %z1, %z2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3 },
    &operand_data[41],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:722 */
  {
    "mulsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_36 },
#else
    { 0, output_36, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3 },
    &operand_data[21],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:733 */
  {
    "udivsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "divu     %0, %z1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_udivsi3 },
    &operand_data[44],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:742 */
  {
    "umodsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "modu     %0, %z1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umodsi3 },
    &operand_data[44],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:755 */
  {
    "negsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub      %0, r0, %z1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsi2 },
    &operand_data[41],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:763 */
  {
    "one_cmplsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "not      %0, %z1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplsi2 },
    &operand_data[41],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:775 */
  {
    "andsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_41 },
#else
    { 0, output_41, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andsi3 },
    &operand_data[47],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:786 */
  {
    "iorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_42 },
#else
    { 0, output_42, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorsi3 },
    &operand_data[47],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:797 */
  {
    "xorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_43 },
#else
    { 0, output_43, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3 },
    &operand_data[47],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:808 */
  {
    "*norsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_44 },
#else
    { 0, output_44, 0 },
#endif
    { 0 },
    &operand_data[47],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:819 */
  {
    "*xnorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_45 },
#else
    { 0, output_45, 0 },
#endif
    { 0 },
    &operand_data[47],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:862 */
  {
    "*ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_46 },
#else
    { 0, output_46, 0 },
#endif
    { 0 },
    &operand_data[27],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:902 */
  {
    "*ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_47 },
#else
    { 0, output_47, 0 },
#endif
    { 0 },
    &operand_data[27],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:913 */
  {
    "ashrsi3_1bit",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sri      %0, %z1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3_1bit },
    &operand_data[50],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:951 */
  {
    "*lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_49 },
#else
    { 0, output_49, 0 },
#endif
    { 0 },
    &operand_data[27],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/lm32/lm32.md:962 */
  {
    "lshrsi3_1bit",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "srui     %0, %z1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3_1bit },
    &operand_data[50],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:997 */
  {
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nop },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:1011 */
  {
    "blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_blockage },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/lm32/lm32.md:100 */
  {
    "movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi },
    &operand_data[53],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:116 */
  {
    "movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi },
    &operand_data[55],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:132 */
  {
    "movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi },
    &operand_data[57],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:219 */
  {
    "cpymemsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cpymemsi },
    &operand_data[59],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:382 */
  {
    "cstoresi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cstoresi4 },
    &operand_data[63],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:481 */
  {
    "cbranchsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsi4 },
    &operand_data[67],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:583 */
  {
    "call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call },
    &operand_data[70],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:607 */
  {
    "call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value },
    &operand_data[70],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:641 */
  {
    "return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:647 */
  {
    "simple_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_simple_return },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:671 */
  {
    "tablejump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump },
    &operand_data[73],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:834 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3 },
    &operand_data[75],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:873 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3 },
    &operand_data[75],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:922 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3 },
    &operand_data[75],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:975 */
  {
    "prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/config/lm32/lm32.md:984 */
  {
    "epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
