/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 147)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 147
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[0] = x7;
  if (!bitwise_memory_operand (operands[0], E_QImode))
    return -1;
  x8 = XEXP (x4, 2);
  operands[1] = x8;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 147
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x4, 0);
  operands[2] = x14;
  if (!arith_reg_dest (operands[2], E_SImode))
    return -1;
  x15 = XEXP (x6, 0);
  operands[1] = x15;
  x16 = XEXP (x9, 0);
  operands[0] = x16;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x17 = XEXP (x10, 0);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  return 0;
}

int
pattern44 (rtx x1, rtx_code i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern51 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 147
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      return 0;

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != LSHIFTRT
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != ASHIFT
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x7, 1);
      operands[1] = x10;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x11 = XEXP (x8, 0);
      operands[2] = x11;
      if (!arith_reg_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x8, 1);
      operands[3] = x12;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 33)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 147
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 0
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 0);
  x11 = XEXP (x10, 1);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  x13 = XEXP (x11, 1);
  operands[2] = x13;
  x14 = XEXP (x4, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x4, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x2, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern38 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern38 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!fp_arith_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !fp_arith_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!fp_arith_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !fp_arith_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 147
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_QImode:
          return 0;

        case E_HImode:
          return 1;

        default:
          return -1;
        }

    case USE:
      x5 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!gbr_displacement (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1, rtx_code i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 154
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x4))
    {
    case USE:
      return 0;

    case CLOBBER:
      return 1;

    default:
      return -1;
    }
}

int
pattern135 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !arith_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern141 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 14)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  return pattern140 (x5, 
147, 
15); /* [-1, 0] */
}

int
pattern149 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !arith_reg_operand (operands[0], E_SImode)
      || !arith_reg_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!arith_reg_dest (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !arith_reg_operand (operands[1], E_DImode)
          || !arith_reg_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !arith_reg_operand (operands[1], E_SImode)
          || !treg_set_expr_not_const01 (operands[2], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern166 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!gbr_displacement (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      return pattern165 (x5, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (pattern165 (x5, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (pattern165 (x5, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !atomic_arith_operand_1 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 147
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 0
          || GET_MODE (x11) != E_SImode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern165 (x3, 
E_SImode); /* [-1, 0] */

        case E_QImode:
          if (pattern165 (x3, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_HImode:
          if (pattern165 (x3, 
E_HImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CLOBBER:
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 0
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern181 (x3, 
E_QImode) != 0)
            return -1;
          return 3;

        case E_HImode:
          if (pattern181 (x3, 
E_HImode) != 0)
            return -1;
          return 4;

        case E_SImode:
          if (pattern181 (x3, 
E_SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern205 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern205 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern205 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !logical_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern223 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i5
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i4
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i3
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i1)
    return -1;
  return 0;
}

int
pattern231 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!logical_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !arith_reg_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern254 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !atomic_arith_operand_1 (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern263 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  return pattern240 (x7, 
i1); /* [-1, 0] */
}

int
pattern272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !atomic_mem_operand_1 (operands[1], i1)
      || !arith_reg_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x2, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern280 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern280 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case XOR:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || pattern53 (x1, 
147) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!arith_reg_operand (operands[1], E_SImode)
          || !
#line 1007 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 16; /* cmp_div0s */

    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
          switch (XWINT (x4, 0))
            {
            case 31L:
              if (pattern53 (x1, 
147) == 0)
                {
                  operands[0] = x3;
                  if (arith_reg_operand (operands[0], E_SImode)
                      && 
#line 2863 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                    return 95; /* *reg_msb_t */
                }
              break;

            case 1L:
              if (pnum_clobbers != NULL)
                {
                  x7 = XEXP (x1, 0);
                  operands[0] = x7;
                  if (arith_reg_dest (operands[0], E_DImode)
                      && GET_MODE (x2) == E_DImode)
                    {
                      operands[1] = x3;
                      if (arith_reg_operand (operands[1], E_DImode)
                          && 
#line 4104 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                        {
                          *pnum_clobbers = 1;
                          return 141; /* lshrdi3_k */
                        }
                    }
                }
              break;

            default:
              break;
            }
          operands[2] = x4;
          x7 = XEXP (x1, 0);
          operands[0] = x7;
          if (!arith_reg_dest (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[1] = x3;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          if (p27_rshift_count_operand (operands[2], E_SImode)
              && 
#line 3959 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return 135; /* lshrsi3_k */
          if (!not_p27_rshift_count_operand (operands[2], E_SImode))
            return -1;
          if (
#line 4025 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! sh_lshrsi_clobbers_t_reg_p (operands[2])))
            return 138; /* lshrsi3_n */
          if (pnum_clobbers == NULL
              || !
#line 4051 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && sh_lshrsi_clobbers_t_reg_p (operands[2])))
            return -1;
          *pnum_clobbers = 1;
          return 139; /* lshrsi3_n_clobbers_t */

        case NEG:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[0] = x7;
          if (!arith_reg_dest (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[1] = x3;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          if (!shift_count_operand (operands[2], E_SImode)
              || !
#line 3967 "../../gcc/config/sh/sh.md"
(TARGET_DYNSHIFT))
            return -1;
          return 136; /* lshrsi3_d */

        default:
          return -1;
        }

    case ASHIFT:
      if (pnum_clobbers == NULL
          || pattern17 (x3, 
LSHIFTRT) != 0)
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x3, 0);
      x9 = XEXP (x5, 0);
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x9, 1);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x5, 1);
      operands[3] = x12;
      x6 = XEXP (x3, 1);
      operands[4] = x6;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[5] = x4;
      if (!const_int_operand (operands[5], E_SImode)
          || !
#line 4205 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      *pnum_clobbers = 1;
      return 144; /* and_shl_scratch */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
      if (REGNO (x2) != 144
          || GET_MODE (x2) != E_SImode
          || !arith_reg_dest (operands[0], E_SImode))
        return -1;
      return 258; /* store_gbr */

    case MEM:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_CODE (x3))
        {
        case PLUS:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 144
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!arith_reg_dest (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !gbr_displacement (operands[1], E_QImode)
                  || !
#line 7705 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 260; /* *movqi_gbr_load */

            case E_HImode:
              if (!arith_reg_dest (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !gbr_displacement (operands[1], E_HImode)
                  || !
#line 7705 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 261; /* *movhi_gbr_load */

            case E_SImode:
              if (!arith_reg_dest (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !gbr_displacement (operands[1], E_SImode)
                  || !
#line 7705 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 262; /* *movsi_gbr_load */

            default:
              return -1;
            }

        case REG:
          if (REGNO (x3) != 144)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!arith_reg_dest (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !
#line 7712 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 263; /* *movqi_gbr_load */

            case E_HImode:
              if (!arith_reg_dest (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !
#line 7712 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 264; /* *movhi_gbr_load */

            case E_SImode:
              if (!arith_reg_dest (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !
#line 7712 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 265; /* *movsi_gbr_load */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (arith_reg_operand (operands[1], E_SImode))
    {
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pnum_clobbers != NULL
          && treg_set_expr_not_const01 (operands[2], E_VOIDmode)
          && 
#line 1725 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        {
          *pnum_clobbers = 1;
          return 44; /* *addc_r_t */
        }
      if (arith_or_int_operand (operands[2], E_SImode))
        {
          if (
#line 1810 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && sh_lra_p ()
   && (! reg_overlap_mentioned_p (operands[0], operands[1])
       || arith_operand (operands[2], SImode))))
            return 48; /* *addsi3_compact_lra */
          if (pnum_clobbers != NULL
              && 
#line 1832 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            {
              *pnum_clobbers = 1;
              return 49; /* addsi3_scr */
            }
          if (
#line 1882 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !sh_lra_p ()
   && (reload_completed || reload_in_progress)
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && (!reload_in_progress
       || ((!REG_P (operands[1]) || REGNO (operands[1]) != SP_REG)
	   && (!REG_P (operands[2]) || REGNO (operands[2]) != SP_REG)))))
            return 50; /* *addsi3 */
        }
      if (arith_operand (operands[2], E_SImode)
          && 
#line 1918 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !sh_lra_p ()))
        return 51; /* *addsi3 */
    }
  if (pnum_clobbers == NULL
      || !treg_set_expr (operands[1], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!arith_reg_operand (operands[2], E_SImode)
      || !
#line 1739 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
    return -1;
  *pnum_clobbers = 1;
  return 45; /* *addc_2r_t */
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (pattern125 (x1, 
SET, 
147) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LTU
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 147
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  if (!arith_reg_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x4, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[1])
      || !
#line 1567 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
    return -1;
  return 37; /* addc */
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (GET_MODE (x5) == E_SImode)
        {
          x6 = XVECEXP (x1, 0, 1);
          if (pattern84 (x6, 
CLOBBER) == 0
              && pattern154 (x4) == 0
              && 
#line 1766 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 47; /* *addc_negreg_t */
        }
      break;

    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern84 (x6, 
CLOBBER) == 0)
        {
          switch (pattern155 (x4))
            {
            case 0:
              if (
#line 1937 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                return 52; /* subdi3 */
              break;

            case 1:
              if (
#line 2060 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                return 57; /* *subc */
              break;

            default:
              break;
            }
        }
      break;

    case MINUS:
      if (pattern83 (x4) == 0)
        {
          if (arith_reg_operand (operands[2], E_SImode))
            {
              res = recog_43 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) == CLOBBER)
            {
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) == REG
                  && REGNO (x7) == 147
                  && GET_MODE (x7) == E_SImode)
                {
                  x8 = XEXP (x4, 1);
                  operands[3] = x8;
                  if (treg_set_expr (operands[3], E_VOIDmode)
                      && arith_reg_or_0_operand (operands[2], E_SImode)
                      && 
#line 1976 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                    return 54; /* *subc */
                  if (arith_reg_operand (operands[3], E_SImode)
                      && treg_set_expr (operands[2], E_VOIDmode)
                      && 
#line 2017 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                    return 55; /* *subc */
                }
            }
        }
      break;

    case MEM:
      if (pattern62 (x1, pnum_clobbers, 
MINUS) == 0)
        {
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (pattern191 (x1))
            {
            case 0:
              if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 2;
                  return 602; /* atomic_sub_fetchqi_soft_gusa */
                }
              if (
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                {
                  *pnum_clobbers = 1;
                  return 638; /* atomic_sub_fetchqi_soft_imask */
                }
              break;

            case 1:
              if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 2;
                  return 607; /* atomic_sub_fetchhi_soft_gusa */
                }
              if (
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                {
                  *pnum_clobbers = 1;
                  return 643; /* atomic_sub_fetchhi_soft_imask */
                }
              break;

            case 2:
              if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 2;
                  return 612; /* atomic_sub_fetchsi_soft_gusa */
                }
              if (
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                {
                  *pnum_clobbers = 1;
                  return 648; /* atomic_sub_fetchsi_soft_imask */
                }
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (pattern84 (x6, 
CLOBBER) != 0
      || GET_MODE (x4) != E_SImode)
    return -1;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  if (arith_reg_operand (operands[2], E_SImode))
    {
      operands[1] = x5;
      if (treg_set_expr_not_const01 (operands[1], E_VOIDmode)
          && 
#line 2075 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return 58; /* *subc_negt_reg */
    }
  if (!treg_set_expr (operands[2], E_VOIDmode)
      || GET_CODE (x5) != NEG
      || GET_MODE (x5) != E_SImode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  if (!arith_reg_operand (operands[1], E_SImode)
      || !
#line 4366 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
    return -1;
  return 150; /* *negc */
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (pattern61 (x3, 
NOT) != 0)
    return -1;
  switch (pattern138 (x1))
    {
    case 0:
      switch (pattern172 (x1))
        {
        case 0:
          if (
#line 1790 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 616; /* atomic_not_fetchqi_soft_gusa */
            }
          if (!
#line 1899 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 652; /* atomic_not_fetchqi_soft_imask */

        case 1:
          if (
#line 1790 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 617; /* atomic_not_fetchhi_soft_gusa */
            }
          if (!
#line 1899 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 653; /* atomic_not_fetchhi_soft_imask */

        case 2:
          if (
#line 1790 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 618; /* atomic_not_fetchsi_soft_gusa */
            }
          if (!
#line 1899 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 654; /* atomic_not_fetchsi_soft_imask */

        default:
          return -1;
        }

    case 1:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern235 (x1, 
E_QImode) != 0)
            return -1;
          if (arith_reg_operand (operands[2], E_QImode)
              && 
#line 2054 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 660; /* atomic_nand_fetchqi_soft_gusa */
            }
          if (!logical_operand (operands[2], E_QImode)
              || !
#line 2113 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 666; /* atomic_nand_fetchqi_soft_imask */

        case E_HImode:
          if (pattern235 (x1, 
E_HImode) != 0)
            return -1;
          if (arith_reg_operand (operands[2], E_HImode)
              && 
#line 2054 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 661; /* atomic_nand_fetchhi_soft_gusa */
            }
          if (!logical_operand (operands[2], E_HImode)
              || !
#line 2113 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 667; /* atomic_nand_fetchhi_soft_imask */

        case E_SImode:
          if (pattern235 (x1, 
E_SImode) != 0)
            return -1;
          if (arith_reg_operand (operands[2], E_SImode)
              && 
#line 2054 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 662; /* atomic_nand_fetchsi_soft_gusa */
            }
          if (!logical_operand (operands[2], E_SImode)
              || !
#line 2113 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 668; /* atomic_nand_fetchsi_soft_imask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XINT (x3, 1))
        {
        case 18:
          if (pnum_clobbers == NULL
              || pattern102 (x1, 
12, 
144, 
USE, 
E_SImode) != 0
              || !register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x3, 0, 0);
          operands[1] = x5;
          *pnum_clobbers = 1;
          return 257; /* tls_initial_exec */

        case 13:
          if (pattern102 (x1, 
154, 
155, 
CLOBBER, 
E_SFmode) != 0
              || !fp_arith_reg_operand (operands[0], E_SFmode))
            return -1;
          x5 = XVECEXP (x3, 0, 0);
          operands[1] = x5;
          if (!fp_arith_reg_operand (operands[1], E_SFmode)
              || !
#line 9457 "../../gcc/config/sh/sh.md"
(TARGET_FPU_ANY && TARGET_FSRRA))
            return -1;
          return 342; /* rsqrtsf2 */

        case 33:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern67 (x1, 
0, 
147, 
CLOBBER) != 0)
            return -1;
          switch (pattern222 (x3))
            {
            case 0:
              if (!
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 456; /* atomic_addqi_hard */

            case 1:
              if (!
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 461; /* atomic_addhi_hard */

            case 2:
              if (!
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 457; /* atomic_subqi_hard */

            case 3:
              if (!
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 462; /* atomic_subhi_hard */

            case 4:
              if (!
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 458; /* atomic_orqi_hard */

            case 5:
              if (!
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 463; /* atomic_orhi_hard */

            case 6:
              if (!
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 459; /* atomic_xorqi_hard */

            case 7:
              if (!
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 464; /* atomic_xorhi_hard */

            case 8:
              if (!
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 460; /* atomic_andqi_hard */

            case 9:
              if (!
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 465; /* atomic_andhi_hard */

            case 10:
              if (!
#line 1394 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 557; /* atomic_nandqi_hard */

            case 11:
              if (!
#line 1394 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 558; /* atomic_nandhi_hard */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x3, 1) != 26
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 147
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[0] = x5;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x10 = XVECEXP (x3, 0, 1);
      operands[1] = x10;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x6, 0);
      operands[2] = x11;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x8, 0);
      operands[3] = x12;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      return 401; /* stack_protect_test_si */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 154
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 146
          || GET_MODE (x7) != E_SImode
          || !arith_reg_operand (operands[0], E_SImode)
          || !
#line 6502 "../../gcc/config/sh/sh.md"
(TARGET_FDPIC))
        return -1;
      return 225; /* calli_fdpic */

    case USE:
      if (pnum_clobbers == NULL
          || !arith_reg_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!
#line 6548 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
        return -1;
      *pnum_clobbers = 1;
      return 227; /* calli_pcrel */

    case RETURN:
      if (!register_operand (operands[0], E_SImode)
          || !
#line 6813 "../../gcc/config/sh/sh.md"
(TARGET_FDPIC))
        return -1;
      return 235; /* sibcalli_fdpic */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74, x75, x76, x77, x78;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x2, 0);
  operands[0] = x13;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x14 = XEXP (x5, 0);
  if (GET_MODE (x14) != E_SImode)
    return -1;
  x15 = XEXP (x5, 1);
  if (GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XEXP (x6, 0);
  if (GET_MODE (x16) != E_SImode)
    return -1;
  x17 = XEXP (x6, 1);
  if (GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XEXP (x7, 0);
  if (GET_MODE (x18) != E_SImode)
    return -1;
  x19 = XEXP (x7, 1);
  if (GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XEXP (x8, 0);
  if (GET_MODE (x20) != E_SImode)
    return -1;
  x21 = XEXP (x8, 1);
  if (GET_MODE (x21) != E_SImode)
    return -1;
  x22 = XEXP (x9, 0);
  if (GET_MODE (x22) != E_SImode)
    return -1;
  x23 = XEXP (x9, 1);
  if (GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XEXP (x10, 0);
  if (GET_MODE (x24) != E_SImode)
    return -1;
  x25 = XEXP (x10, 1);
  if (GET_MODE (x25) != E_SImode)
    return -1;
  x26 = XEXP (x11, 0);
  if (GET_MODE (x26) != E_SImode)
    return -1;
  x27 = XEXP (x11, 1);
  if (GET_MODE (x27) != E_SImode)
    return -1;
  x28 = XEXP (x12, 0);
  if (GET_MODE (x28) != E_SImode)
    return -1;
  x29 = XEXP (x12, 1);
  if (GET_MODE (x29) != E_SImode)
    return -1;
  x30 = XEXP (x3, 0);
  if (!rtx_equal_p (x30, operands[0]))
    return -1;
  switch (XWINT (x4, 0))
    {
    case -32L:
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 7
          || GET_CODE (x14) != MEM)
        return -1;
      x31 = XEXP (x14, 0);
      if (GET_CODE (x31) != PLUS
          || GET_MODE (x31) != E_SImode)
        return -1;
      x32 = XEXP (x31, 1);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 28]
          || GET_CODE (x17) != REG
          || REGNO (x17) != 6
          || GET_CODE (x16) != MEM)
        return -1;
      x33 = XEXP (x16, 0);
      if (GET_CODE (x33) != PLUS
          || GET_MODE (x33) != E_SImode)
        return -1;
      x34 = XEXP (x33, 1);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 24]
          || GET_CODE (x19) != REG
          || REGNO (x19) != 5
          || GET_CODE (x18) != MEM)
        return -1;
      x35 = XEXP (x18, 0);
      if (GET_CODE (x35) != PLUS
          || GET_MODE (x35) != E_SImode)
        return -1;
      x36 = XEXP (x35, 1);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 20]
          || GET_CODE (x21) != REG
          || REGNO (x21) != 4
          || GET_CODE (x20) != MEM)
        return -1;
      x37 = XEXP (x20, 0);
      if (GET_CODE (x37) != PLUS
          || GET_MODE (x37) != E_SImode)
        return -1;
      x38 = XEXP (x37, 1);
      if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || GET_CODE (x23) != REG
          || REGNO (x23) != 3
          || GET_CODE (x22) != MEM)
        return -1;
      x39 = XEXP (x22, 0);
      if (GET_CODE (x39) != PLUS
          || GET_MODE (x39) != E_SImode)
        return -1;
      x40 = XEXP (x39, 1);
      if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 12]
          || GET_CODE (x25) != REG
          || REGNO (x25) != 2
          || GET_CODE (x24) != MEM)
        return -1;
      x41 = XEXP (x24, 0);
      if (GET_CODE (x41) != PLUS
          || GET_MODE (x41) != E_SImode)
        return -1;
      x42 = XEXP (x41, 1);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
          || GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_CODE (x26) != MEM)
        return -1;
      x43 = XEXP (x26, 0);
      if (GET_CODE (x43) != PLUS
          || GET_MODE (x43) != E_SImode)
        return -1;
      x44 = XEXP (x43, 1);
      if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
          || GET_CODE (x29) != REG
          || REGNO (x29) != 0
          || GET_CODE (x28) != MEM)
        return -1;
      x45 = XEXP (x28, 0);
      if (GET_CODE (x45) != PLUS
          || GET_MODE (x45) != E_SImode)
        return -1;
      x46 = XEXP (x45, 1);
      if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x47 = XEXP (x31, 0);
      if (!rtx_equal_p (x47, operands[0]))
        return -1;
      x48 = XEXP (x33, 0);
      if (!rtx_equal_p (x48, operands[0]))
        return -1;
      x49 = XEXP (x35, 0);
      if (!rtx_equal_p (x49, operands[0]))
        return -1;
      x50 = XEXP (x37, 0);
      if (!rtx_equal_p (x50, operands[0]))
        return -1;
      x51 = XEXP (x39, 0);
      if (!rtx_equal_p (x51, operands[0]))
        return -1;
      x52 = XEXP (x41, 0);
      if (!rtx_equal_p (x52, operands[0]))
        return -1;
      x53 = XEXP (x43, 0);
      if (!rtx_equal_p (x53, operands[0]))
        return -1;
      x54 = XEXP (x45, 0);
      if (!rtx_equal_p (x54, operands[0])
          || !
#line 8134 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && REGNO (operands[0]) == 15))
        return -1;
      return 286; /* movml_push_banked */

    case 32L:
      if (GET_CODE (x15) != MEM)
        return -1;
      x55 = XEXP (x15, 0);
      if (GET_CODE (x55) != PLUS
          || GET_MODE (x55) != E_SImode)
        return -1;
      x56 = XEXP (x55, 1);
      if (x56 != const_int_rtx[MAX_SAVED_CONST_INT + -32]
          || GET_CODE (x14) != REG
          || REGNO (x14) != 0
          || GET_CODE (x17) != MEM)
        return -1;
      x57 = XEXP (x17, 0);
      if (GET_CODE (x57) != PLUS
          || GET_MODE (x57) != E_SImode)
        return -1;
      x58 = XEXP (x57, 1);
      if (x58 != const_int_rtx[MAX_SAVED_CONST_INT + -28]
          || GET_CODE (x16) != REG
          || REGNO (x16) != 1
          || GET_CODE (x19) != MEM)
        return -1;
      x59 = XEXP (x19, 0);
      if (GET_CODE (x59) != PLUS
          || GET_MODE (x59) != E_SImode)
        return -1;
      x60 = XEXP (x59, 1);
      if (x60 != const_int_rtx[MAX_SAVED_CONST_INT + -24]
          || GET_CODE (x18) != REG
          || REGNO (x18) != 2
          || GET_CODE (x21) != MEM)
        return -1;
      x61 = XEXP (x21, 0);
      if (GET_CODE (x61) != PLUS
          || GET_MODE (x61) != E_SImode)
        return -1;
      x62 = XEXP (x61, 1);
      if (x62 != const_int_rtx[MAX_SAVED_CONST_INT + -20]
          || GET_CODE (x20) != REG
          || REGNO (x20) != 3
          || GET_CODE (x23) != MEM)
        return -1;
      x63 = XEXP (x23, 0);
      if (GET_CODE (x63) != PLUS
          || GET_MODE (x63) != E_SImode)
        return -1;
      x64 = XEXP (x63, 1);
      if (x64 != const_int_rtx[MAX_SAVED_CONST_INT + -16]
          || GET_CODE (x22) != REG
          || REGNO (x22) != 4
          || GET_CODE (x25) != MEM)
        return -1;
      x65 = XEXP (x25, 0);
      if (GET_CODE (x65) != PLUS
          || GET_MODE (x65) != E_SImode)
        return -1;
      x66 = XEXP (x65, 1);
      if (x66 != const_int_rtx[MAX_SAVED_CONST_INT + -12]
          || GET_CODE (x24) != REG
          || REGNO (x24) != 5
          || GET_CODE (x27) != MEM)
        return -1;
      x67 = XEXP (x27, 0);
      if (GET_CODE (x67) != PLUS
          || GET_MODE (x67) != E_SImode)
        return -1;
      x68 = XEXP (x67, 1);
      if (x68 != const_int_rtx[MAX_SAVED_CONST_INT + -8]
          || GET_CODE (x26) != REG
          || REGNO (x26) != 6
          || GET_CODE (x29) != MEM)
        return -1;
      x69 = XEXP (x29, 0);
      if (GET_CODE (x69) != PLUS
          || GET_MODE (x69) != E_SImode)
        return -1;
      x70 = XEXP (x69, 1);
      if (x70 != const_int_rtx[MAX_SAVED_CONST_INT + -4]
          || GET_CODE (x28) != REG
          || REGNO (x28) != 7)
        return -1;
      x71 = XEXP (x55, 0);
      if (!rtx_equal_p (x71, operands[0]))
        return -1;
      x72 = XEXP (x57, 0);
      if (!rtx_equal_p (x72, operands[0]))
        return -1;
      x73 = XEXP (x59, 0);
      if (!rtx_equal_p (x73, operands[0]))
        return -1;
      x74 = XEXP (x61, 0);
      if (!rtx_equal_p (x74, operands[0]))
        return -1;
      x75 = XEXP (x63, 0);
      if (!rtx_equal_p (x75, operands[0]))
        return -1;
      x76 = XEXP (x65, 0);
      if (!rtx_equal_p (x76, operands[0]))
        return -1;
      x77 = XEXP (x67, 0);
      if (!rtx_equal_p (x77, operands[0]))
        return -1;
      x78 = XEXP (x69, 0);
      if (!rtx_equal_p (x78, operands[0])
          || !
#line 8149 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && REGNO (operands[0]) == 15))
        return -1;
      return 287; /* movml_pop_banked */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case XOR:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 147
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case GE:
          if (pattern105 (x2, 
0) != 0
              || !(
#line 1017 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1019 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_14 (insn, operands);

        case LSHIFTRT:
          if (pattern105 (x2, 
31) != 0
              || !(
#line 1066 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_18 (insn, operands);

        case REG:
        case SUBREG:
        case NE:
        case EQ:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
          operands[0] = x4;
          if (!t_reg_operand (operands[0], E_SImode))
            return NULL;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !
#line 8452 "../../gcc/config/sh/sh.md"
(!TARGET_SH2A && can_create_pseudo_p () && !sh_in_recog_treg_set_expr ()))
            return NULL;
          return gen_split_164 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
            return NULL;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!arith_reg_dest (operands[0], E_SImode))
            return NULL;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!arith_reg_operand (operands[1], E_SImode)
              || !(
#line 1668 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_SH2A && can_create_pseudo_p ()
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 1671 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_35 (insn, operands);

        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          operands[1] = x4;
          if (arith_reg_operand (operands[1], E_SImode))
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (arith_reg_dest (operands[0], E_SImode))
                {
                  x5 = XEXP (x2, 1);
                  operands[2] = x5;
                  if (logical_and_operand (operands[2], E_SImode)
                      && (
#line 2762 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 2768 "../../gcc/config/sh/sh.md"
( 1)))
                    return gen_split_60 (insn, operands);
                }
            }
          operands[0] = x4;
          if (!arith_reg_operand (operands[0], E_SImode)
              || pattern12 (x1, 
1) != 0
              || !(
#line 2850 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 2852 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_62 (insn, operands);

        case ASHIFT:
          if (GET_MODE (x4) != E_SImode
              || pattern95 (x1) != 0
              || !
#line 4124 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && reload_completed && (unsigned)INTVAL (operands[2]) < 32))
            return NULL;
          return gen_split_92 (insn, operands);

        case NOT:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          switch (pattern59 (x1))
            {
            case 0:
              x7 = XEXP (x4, 0);
              operands[0] = x7;
              if (arith_reg_operand (operands[0], E_SImode)
                  && (
#line 10052 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 10054 "../../gcc/config/sh/sh.md"
( 1)))
                return gen_split_178 (insn, operands);
              if (GET_CODE (x7) != SUBREG)
                return NULL;
              switch (pattern153 (x7))
                {
                case 0:
                  if (!(
#line 10130 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_LITTLE_ENDIAN && can_create_pseudo_p ()
   && INTVAL (operands[1]) < 32) && 
#line 10133 "../../gcc/config/sh/sh.md"
( 1)))
                    return NULL;
                  return gen_split_185 (insn, operands);

                case 1:
                  if (!(
#line 10147 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_BIG_ENDIAN && can_create_pseudo_p ()
   && INTVAL (operands[1]) < 32) && 
#line 10150 "../../gcc/config/sh/sh.md"
( 1)))
                    return NULL;
                  return gen_split_186 (insn, operands);

                default:
                  return NULL;
                }

            case 1:
              if (!(
#line 10114 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && INTVAL (operands[3]) > 0
   && INTVAL (operands[1]) + INTVAL (operands[3]) == 32) && 
#line 10118 "../../gcc/config/sh/sh.md"
( 1)))
                return NULL;
              return gen_split_184 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          if (GET_MODE (x4) != E_SImode
              || pattern60 (x1) != 0
              || !(
#line 10096 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && INTVAL (operands[4]) > 0
   && INTVAL (operands[1]) & (1LL << INTVAL (operands[2]))) && 
#line 10100 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_183 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!arith_reg_dest (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ASHIFT:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != CONST_INT)
            return NULL;
          if (XWINT (x6, 0) == 31L)
            {
              x5 = XEXP (x2, 1);
              if (GET_CODE (x5) == LSHIFTRT
                  && GET_MODE (x5) == E_SImode)
                {
                  x7 = XEXP (x4, 0);
                  operands[1] = x7;
                  if (arith_reg_or_treg_set_expr (operands[1], E_VOIDmode))
                    {
                      x8 = XEXP (x5, 0);
                      operands[2] = x8;
                      if (arith_reg_or_0_operand (operands[2], E_SImode))
                        {
                          x9 = XEXP (x5, 1);
                          operands[3] = x9;
                          if (const_int_operand (operands[3], E_SImode)
                              && 
#line 3162 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                            return gen_split_65 (insn, operands);
                        }
                    }
                }
            }
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_SImode))
            return NULL;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!arith_reg_operand (operands[2], E_SImode))
            return NULL;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!negt_reg_operand (operands[1], E_SImode)
              || !
#line 3464 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return NULL;
          return gen_split_78 (insn, operands);

        case SUBREG:
        case XOR:
        case NE:
        case EQ:
          operands[1] = x4;
          if (!negt_reg_operand (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != ASHIFT
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!arith_reg_operand (operands[2], E_SImode))
            return NULL;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          if (!const_int_operand (operands[3], E_SImode)
              || !
#line 3452 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return NULL;
          return gen_split_77 (insn, operands);

        case AND:
          if (pattern103 (x4, 
8, 
ASHIFT) != 0)
            return NULL;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != CONST_INT)
            return NULL;
          switch (pattern163 (x2))
            {
            case 0:
              if (!(
#line 4625 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! reload_in_progress && ! reload_completed && can_create_pseudo_p ()) && 
#line 4627 "../../gcc/config/sh/sh.md"
( 1)))
                return NULL;
              return gen_split_105 (insn, operands);

            case 1:
              if (!(
#line 4647 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! reload_in_progress && ! reload_completed && can_create_pseudo_p ()) && 
#line 4649 "../../gcc/config/sh/sh.md"
( 1)))
                return NULL;
              return gen_split_106 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (pattern51 (x1, 
147, 
CLOBBER) != 0)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) == E_SImode
          && pattern154 (x3) == 0
          && (
#line 1766 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1768 "../../gcc/config/sh/sh.md"
( 1)))
        return gen_split_41 (insn, operands);
      break;

    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[1] = x4;
      switch (pattern155 (x3))
        {
        case 0:
          if ((
#line 1937 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1939 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_46 (insn, operands);
          break;

        case 1:
          if ((
#line 2060 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 2062 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_50 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case MINUS:
      if (pattern83 (x3) == 0)
        {
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (treg_set_expr (operands[3], E_VOIDmode)
              && arith_reg_or_0_operand (operands[2], E_SImode)
              && (
#line 1976 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1978 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_47 (insn, operands);
          if (arith_reg_operand (operands[3], E_SImode)
              && treg_set_expr (operands[2], E_VOIDmode)
              && (
#line 2017 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 2019 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_48 (insn, operands);
        }
      break;

    default:
      break;
    }
  if (!arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return NULL;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (arith_reg_operand (operands[2], E_SImode))
    {
      operands[1] = x4;
      if (treg_set_expr_not_const01 (operands[1], E_VOIDmode)
          && (
#line 2075 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 2077 "../../gcc/config/sh/sh.md"
( 1)))
        return gen_split_51 (insn, operands);
    }
  if (!treg_set_expr (operands[2], E_VOIDmode)
      || GET_CODE (x4) != NEG
      || GET_MODE (x4) != E_SImode)
    return NULL;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!arith_reg_operand (operands[1], E_SImode)
      || !(
#line 4366 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 4368 "../../gcc/config/sh/sh.md"
( 1)))
    return NULL;
  return gen_split_96 (insn, operands);
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MULT:
      if (GET_MODE (x3) != E_DImode
          || pattern75 (x1, 
149, 
148) != 0)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!arith_reg_dest (operands[0], E_DImode))
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_MODE (x5) != E_DImode)
        return NULL;
      x6 = XEXP (x3, 1);
      if (GET_MODE (x6) != E_DImode)
        return NULL;
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x6) != SIGN_EXTEND)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!arith_reg_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!arith_reg_operand (operands[2], E_SImode)
              || !(
#line 2599 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()) && 
#line 2601 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_56 (insn, operands);

        case ZERO_EXTEND:
          if (GET_CODE (x6) != ZERO_EXTEND)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!arith_reg_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!arith_reg_operand (operands[2], E_SImode)
              || !(
#line 2647 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()) && 
#line 2649 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_57 (insn, operands);

        default:
          return NULL;
        }

    case TRUNCATE:
      if (pattern27 (x1) != 0
          || !(
#line 2687 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()) && 
#line 2689 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_58 (insn, operands);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x3;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) == USE
          && pattern76 (x1) == 0)
        {
          x10 = XVECEXP (x1, 0, 2);
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (scratch_operand (operands[2], E_SImode))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_DFmode:
                  if (register_operand (operands[0], E_DFmode)
                      && register_operand (operands[1], E_DFmode)
                      && 
#line 5646 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE && reload_completed
   && (true_regnum (operands[0]) < 16) != (true_regnum (operands[1]) < 16)))
                    return gen_split_118 (insn, operands);
                  if (general_movdst_operand (operands[0], E_DFmode)
                      && general_movsrc_operand (operands[1], E_DFmode)
                      && 
#line 5670 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE
   && reload_completed
   && true_regnum (operands[0]) < 16
   && true_regnum (operands[1]) < 16))
                    return gen_split_119 (insn, operands);
                  break;

                case E_SFmode:
                  if (register_operand (operands[0], E_SFmode)
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 5768 "../../gcc/config/sh/sh.md"
(TARGET_SH2E && reload_completed
   && true_regnum (operands[0]) == true_regnum (operands[1])))
                    return gen_split_121 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x11) == REG
              && GET_MODE (x11) == E_SImode)
            {
              switch (REGNO (x11))
                {
                case 0:
                  if (register_operand (operands[0], E_DFmode)
                      && memory_operand (operands[1], E_DFmode)
                      && 
#line 5741 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE && reload_completed))
                    return gen_split_120 (insn, operands);
                  break;

                case 150:
                  if (register_operand (operands[0], E_SFmode)
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 6241 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                    return gen_split_128 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (register_operand (operands[0], E_DFmode)
              && register_operand (operands[1], E_DFmode))
            {
              operands[2] = x11;
              if (scratch_operand (operands[2], E_SImode)
                  && 
#line 5779 "../../gcc/config/sh/sh.md"
(TARGET_SH4 && ! TARGET_FMOVD && reload_completed
   && FP_OR_XD_REGISTER_P (true_regnum (operands[0]))
   && FP_OR_XD_REGISTER_P (true_regnum (operands[1]))))
                return gen_split_122 (insn, operands);
            }
        }
      if (GET_CODE (x9) != USE
          || pattern76 (x1) != 0)
        return NULL;
      if (register_operand (operands[0], E_DFmode))
        {
          x10 = XVECEXP (x1, 0, 2);
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (scratch_operand (operands[2], E_SImode))
            {
              if (GET_CODE (x3) == MEM
                  && GET_MODE (x3) == E_DFmode)
                {
                  x5 = XEXP (x3, 0);
                  operands[1] = x5;
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 5797 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE && ! TARGET_FMOVD && reload_completed
   && FP_OR_XD_REGISTER_P (true_regnum (operands[0]))
   && find_regno_note (insn, REG_DEAD, true_regnum (operands[1]))))
                    return gen_split_123 (insn, operands);
                }
              operands[1] = x3;
              if (memory_operand (operands[1], E_DFmode)
                  && 
#line 5822 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE && ! TARGET_FMOVD && reload_completed
   && FP_OR_XD_REGISTER_P (true_regnum (operands[0]))))
                return gen_split_124 (insn, operands);
            }
        }
      if (!memory_operand (operands[0], E_DFmode))
        return NULL;
      operands[1] = x3;
      if (!register_operand (operands[1], E_DFmode))
        return NULL;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!scratch_operand (operands[2], E_SImode)
          || !
#line 5889 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE && ! TARGET_FMOVD && reload_completed
   && FP_OR_XD_REGISTER_P (true_regnum (operands[1]))))
        return NULL;
      return gen_split_125 (insn, operands);

    case IF_THEN_ELSE:
      if (pattern29 (x1) != 0
          || !(
#line 6425 "../../gcc/config/sh/sh.md"
(TARGET_SH2) && 
#line 6427 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_131 (insn, operands);

    case XOR:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!arith_reg_dest (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!t_reg_operand (operands[1], E_SImode))
        return NULL;
      switch (pattern145 (x1))
        {
        case 0:
          if (!(
#line 8245 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 8247 "../../gcc/config/sh/sh.md"
( !sh_in_recog_treg_set_expr ())))
            return NULL;
          return gen_split_156 (insn, operands);

        case 1:
          if (!(
#line 8266 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_SH2A) && 
#line 8268 "../../gcc/config/sh/sh.md"
( !sh_in_recog_treg_set_expr ())))
            return NULL;
          return gen_split_157 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (GET_MODE (x3) != E_SFmode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MULT
          || GET_MODE (x5) != E_SFmode
          || pattern65 (x1, 
E_SFmode) != 0)
        return NULL;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!fp_arith_reg_operand (operands[1], E_SFmode))
        return NULL;
      x12 = XEXP (x5, 1);
      operands[2] = x12;
      if (!fp_arith_reg_operand (operands[2], E_SFmode))
        return NULL;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      if (!arith_reg_operand (operands[3], E_SFmode)
          || !(
#line 9280 "../../gcc/config/sh/sh.md"
(TARGET_SH2E && flag_fp_contract_mode == FP_CONTRACT_FAST) && 
#line 9282 "../../gcc/config/sh/sh.md"
( can_create_pseudo_p ())))
        return NULL;
      return gen_split_173 (insn, operands);

    case VEC_CONCAT:
      if (pattern32 (x1) != 0
          || !(
#line 9497 "../../gcc/config/sh/sh.md"
(TARGET_FPU_ANY && TARGET_FSCA) && 
#line 9499 "../../gcc/config/sh/sh.md"
( !fpul_operand (operands[1], SImode))))
        return NULL;
      return gen_split_174 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 33)
        return NULL;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return NULL;
      x13 = XEXP (x9, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern66 (x1, 
0, 
CLOBBER, 
147) != 0)
        return NULL;
      switch (pattern222 (x3))
        {
        case 0:
          if (!(
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 899 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_215 (insn, operands);

        case 1:
          if (!(
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 899 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_220 (insn, operands);

        case 2:
          if (!(
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 899 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_216 (insn, operands);

        case 3:
          if (!(
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 899 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_221 (insn, operands);

        case 4:
          if (!(
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 899 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_217 (insn, operands);

        case 5:
          if (!(
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 899 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_222 (insn, operands);

        case 6:
          if (!(
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 899 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_218 (insn, operands);

        case 7:
          if (!(
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 899 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_223 (insn, operands);

        case 8:
          if (!(
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 899 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_219 (insn, operands);

        case 9:
          if (!(
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 899 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_224 (insn, operands);

        case 10:
          if (!(
#line 1394 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1396 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_284 (insn, operands);

        case 11:
          if (!(
#line 1394 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1396 "../../gcc/config/sh/sync.md"
( 1)))
            return NULL;
          return gen_split_285 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
