static const char *const multilib_raw[] = {
". !ml !m1 !m2 !m2e !m4 !m4-single !m4-single-only !m2a !m2a-single;",
"ml ml !m1 !m2 !m2e !m4 !m4-single !m4-single-only !m2a !m2a-single;",
"m1 !ml m1 !m2 !m2e !m4 !m4-single !m4-single-only !m2a !m2a-single;",
"m2 !ml !m1 m2 !m2e !m4 !m4-single !m4-single-only !m2a !m2a-single;",
"m2e !ml !m1 !m2 m2e !m4 !m4-single !m4-single-only !m2a !m2a-single;",
"m4 !ml !m1 !m2 !m2e m4 !m4-single !m4-single-only !m2a !m2a-single;",
"m4-single !ml !m1 !m2 !m2e !m4 m4-single !m4-single-only !m2a !m2a-single;",
"m4-single-only !ml !m1 !m2 !m2e !m4 !m4-single m4-single-only !m2a !m2a-single;",
"m2a !ml !m1 !m2 !m2e !m4 !m4-single !m4-single-only m2a !m2a-single;",
"m2a-single !ml !m1 !m2 !m2e !m4 !m4-single !m4-single-only !m2a m2a-single;",
"ml/m2 ml !m1 m2 !m2e !m4 !m4-single !m4-single-only !m2a !m2a-single;",
"ml/m2e ml !m1 !m2 m2e !m4 !m4-single !m4-single-only !m2a !m2a-single;",
"ml/m4 ml !m1 !m2 !m2e m4 !m4-single !m4-single-only !m2a !m2a-single;",
"ml/m4-single ml !m1 !m2 !m2e !m4 m4-single !m4-single-only !m2a !m2a-single;",
"ml/m4-single-only ml !m1 !m2 !m2e !m4 !m4-single m4-single-only !m2a !m2a-single;",
NULL
};

static const char *const multilib_reuse_raw[] = {
NULL
};

static const char *const multilib_matches_raw[] = {
"m3 m2;",
"m4-nofpu m2;",
"m4-100-nofpu m2;",
"m4-200-nofpu m2;",
"m4-400 m2;",
"m4-500 m2;",
"m4-340 m2;",
"m4-300-nofpu m2;",
"m4al m2;",
"m4a-nofpu m2;",
"m2a-nofpu m2;",
"m3e m2e;",
"m4-100-single-only m4-single-only;",
"m4-200-single-only m4-single-only;",
"m4-300-single-only m4-single-only;",
"m4a-single-only m4-single-only;",
"m2a-single-only m2a-single;",
"m4-100-single m4-single;",
"m4-200-single m4-single;",
"m4-300-single m4-single;",
"m4a-single m4-single;",
"m4-100 m4;",
"m4-200 m4;",
"m4-300 m4;",
"m4a m4;",
"ml ml;",
"m1 m1;",
"m2 m2;",
"m2e m2e;",
"m4 m4;",
"m4-single m4-single;",
"m4-single-only m4-single-only;",
"m2a m2a;",
"m2a-single m2a-single;",
NULL
};

static const char *multilib_extra = "";

static const char *const multilib_exclusions_raw[] = {
NULL
};

static const char *multilib_options = "ml m1/m2/m2e/m4/m4-single/m4-single-only/m2a/m2a-single";
