/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
insn_current_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 27:  /* *bgeu */
    case 26:  /* *bgtu */
    case 25:  /* *bge */
    case 24:  /* *bgt */
    case 23:  /* *bne */
    case 22:  /* *beq */
      extract_insn_cached (insn);
      if ((abs ((INSN_ADDRESSES_SET_P () ? INSN_ADDRESSES (INSN_UID (GET_CODE (operands[2]) == LABEL_REF ? XEXP (operands[2], 0) : operands[2])) : 0) - (insn_current_reference_address (insn)))) < (32768))
        {
	  return 4;
        }
      else
        {
	  return 8;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      extract_insn_cached (insn);
      if (get_attr_type (insn) == TYPE_CBRANCH)
        {
	  if ((abs ((INSN_ADDRESSES_SET_P () ? INSN_ADDRESSES (INSN_UID (GET_CODE (operands[2]) == LABEL_REF ? XEXP (operands[2], 0) : operands[2])) : 0) - (insn_current_reference_address (insn)))) < (32768))
	    {
	      return 4;
	    }
	  else
	    {
	      return 8;
	    }
        }
      else
        {
	  return 0;
        }

    default:
      return 0;

    }
}

int
insn_variable_length_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 27:  /* *bgeu */
    case 26:  /* *bgtu */
    case 25:  /* *bge */
    case 24:  /* *bgt */
    case 23:  /* *bne */
    case 22:  /* *beq */
      return 1;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if (get_attr_type (insn) == TYPE_CBRANCH)
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    default:
      return 0;

    }
}

int
insn_min_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 52:  /* blockage */
      return 0;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 4;

    }
}

int
insn_default_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 27:  /* *bgeu */
    case 26:  /* *bgtu */
    case 25:  /* *bge */
    case 24:  /* *bgt */
    case 23:  /* *bne */
    case 22:  /* *beq */
      return 8;

    case 52:  /* blockage */
      return 0;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if (get_attr_type (insn) == TYPE_CBRANCH)
        {
	  return 8;
        }
      else
        {
	  return 4;
        }

    default:
      return 4;

    }
}

int
bypass_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
num_delay_slots (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

attr_type
get_attr_type (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 7:  /* movsi_insn */
    case 6:  /* *movhi_insn */
    case 5:  /* *movqi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 1)
        {
	  return TYPE_ARITH;
        }
      else if (((1ULL << which_alternative) & 0xcULL))
        {
	  return TYPE_STORE;
        }
      else
        {
	  return TYPE_ARITH;
        }

    case 8:  /* *extendqihi2 */
    case 9:  /* zero_extendqihi2 */
    case 10:  /* *extendqisi2 */
    case 11:  /* zero_extendqisi2 */
    case 12:  /* *extendhisi2 */
    case 13:  /* zero_extendhisi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_LOAD;
        }
      else
        {
	  return TYPE_ARITH;
        }

    case 28:  /* *call */
    case 29:  /* *call_value */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_CALL;
        }
      else
        {
	  return TYPE_ICALL;
        }

    case 22:  /* *beq */
    case 23:  /* *bne */
    case 24:  /* *bgt */
    case 25:  /* *bge */
    case 26:  /* *bgtu */
    case 27:  /* *bgeu */
      return TYPE_CBRANCH;

    case 21:  /* indirect_jump */
    case 30:  /* return_internal */
    case 31:  /* *return */
    case 32:  /* *simple_return */
      return TYPE_UIBRANCH;

    case 20:  /* jump */
    case 33:  /* tablejumpsi */
      return TYPE_UBRANCH;

    case 37:  /* udivsi3 */
    case 38:  /* umodsi3 */
      return TYPE_DIVIDE;

    case 36:  /* mulsi3 */
      return TYPE_MULTIPLY;

    case 46:  /* *ashlsi3 */
    case 47:  /* *ashrsi3 */
    case 48:  /* ashrsi3_1bit */
    case 49:  /* *lshrsi3 */
    case 50:  /* lshrsi3_1bit */
      return TYPE_SHIFT;

    case 14:  /* *seq */
    case 15:  /* *sne */
    case 16:  /* *sgt */
    case 17:  /* *sge */
    case 18:  /* *sgtu */
    case 19:  /* *sgeu */
      return TYPE_COMPARE;

    case 1:  /* movsi_got */
    case 2:  /* movsi_gotoff_hi16 */
      return TYPE_LOAD;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 52:  /* blockage */
      return TYPE_UNKNOWN;

    default:
      return TYPE_ARITH;

    }
}

int
eligible_for_delay (rtx_insn *delay_insn ATTRIBUTE_UNUSED, int slot, 
		   rtx_insn *candidate_insn, int flags ATTRIBUTE_UNUSED)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;

  if (num_delay_slots (delay_insn) == 0)
    return 0;
  gcc_assert (slot < 0);

  if (!INSN_P (candidate_insn))
    return 0;

  insn = candidate_insn;
  switch (slot)
    {
    default:
      gcc_unreachable ();
    }
}

int
eligible_for_annul_true (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
eligible_for_annul_false (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
const_num_delay_slots (rtx_insn *insn)
{
  switch (recog_memoized (insn))
    {
    default:
      return 1;
    }
}

EXPORTED_CONST int length_unit_log = 2;
